--Define Database to use for this Addon--
DeranjataDB = {}

--define all slash commands to be used for this Addon--
SLASH_DERANJATA1 = "/der"
SlashCmdList["DERANJATA"] = function()MyAddon_ShowOptionFrame()end

SLASH_RELOAD1 = '/rl'
SlashCmdList['RELOAD'] = function() ReloadUI() end

---------------------------------------------------------------------------
--General Layout Prep work to be done before initialization of Layout.lua--
---------------------------------------------------------------------------

--here we will make our screen size calcualtions
local resolHeight = GetScreenHeight () *.65
local resolWidth  = GetScreenWidth () *.65
--now calculate the ratio for a later time
local aspectRatio = (resolWidth/resolHeight)

---------------------------------------------------------
-- Lets free up the combat log so it can be moved arround
---------------------------------------------------------
SetChatWindowShown(2, 1)
SetChatWindowDocked(2, 0)

------------------------------------------------
--now we set all our consol screen view settings
------------------------------------------------
SetCVar("useuiScale", 1);
SetCVar("displaySpellActivationOverlays", 0);
SetCVar("uiScale", 0.60);
--SetCVar("uiScale", 0.60);




-------------------------------------------------
--Here we define all frames that we want to hide 
-------------------------------------------------
local FramesToHide = {
	MainMenuBar, 
	MainMenuBarArtFrame, 
	MainMenuBarPageNumber,
	ActionBarDownButton,
	ActionBarUpButton,
	OverrideActionBar,
	OverrideActionBarExpBar,
	OverrideActionBarHealthBar,
	OverrideActionBarPowerBar,
	OverrideActionBarPitchFrame,
	OverrideActionBarLeaveFrameLeaveButton,
	BonusActionBarFrame, 
	PossessBarFrame,
	MainMenuBarBackpackButton,
	CharacterBag0Slot,
	CharacterBag1Slot,
	CharacterBag2Slot,
	CharacterBag3Slot,
	StanceBarLeft,
	StanceBarMiddle,
	StanceBarRight,
	SlidingActionBarTexture0,
	SlidingActionBarTexture1,
	PossessBackground1,
	PossessBackground2,
	MainMenuBarTexture0,
	MainMenuBarTexture1,
	MainMenuBarTexture2,
	MainMenuBarTexture3,
	MainMenuBarLeftEndCap,
	MainMenuBarRightEndCap,
	}
	
----------------------------------------------------------
--Now here we are processing our frames that we are hiding
----------------------------------------------------------
local frameHider = CreateFrame("Frame", nil)
frameHider:Hide()
for _, f in pairs(FramesToHide) do
    if f:GetObjectType() == "Texture" then
      --f:UnregisterAllEvents()
	  f:SetTexture(nil)
	else
	  f:SetParent(frameHider)
    end
end
local OverrideTexList =  {
	"_BG",
	"_MicroBGMid",
	"_Border",
	"EndCapL",
	"EndCapR",
	"Divider1",
	"Divider2",
	"Divider3",
	"ExitBG",
	"MicroBGL",
	"MicroBGR",
	"ButtonBGL",
	"ButtonBGR",
	"_ButtonBGMid",
	}	
for _, t in pairs(OverrideTexList) do
	OverrideActionBar[t]:SetAlpha(1)
end

----------------------------------------------------------------
--OK Lets make some pretty stuf here----------------------------
----------------------------------------------------------------

--Defining background and frame designs to be used for layout---

local backdrop = {
	bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",
	edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border",
	tile = true,
	tileSize = 32,
	edgeSize = 20,
	insets = {
		left = 4,
		right = 4,
		top = 4,
		bottom = 4,
	}
}
local backdropClear = {
	edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border",
	tile = true,
	tileSize = 32,
	edgeSize = 20,
	insets = {
		left = 4,
		right = 4,
		top = 4,
		bottom = 4,
	}
}
---------------------------------
---Lets begin the basic Framework
---------------------------------

--here we have the chat Frame--
local frame = CreateFrame("frame", "LeftChatBaseFrame", UIParent, BackdropTemplateMixin and "BackdropTemplate")
	LeftChatBaseFrame:SetWidth(resolWidth*.34)
	LeftChatBaseFrame:SetHeight(resolHeight*.33)
	LeftChatBaseFrame:SetPoint("BOTTOMLEFT", UIParent,"BOTTOMLEFT", -6, -6)
	LeftChatBaseFrame:SetFrameStrata("BACKGROUND")
	LeftChatBaseFrame:SetFrameLevel(1)
	LeftChatBaseFrame:SetAlpha(1)
	LeftChatBaseFrame:SetBackdrop(backdrop)
	
-- here we have the combat Frame
local frame = CreateFrame("frame", "RightChatBaseFrame", UIParent, BackdropTemplateMixin and "BackdropTemplate")
	RightChatBaseFrame:SetWidth(resolWidth*.34)
	RightChatBaseFrame:SetHeight(resolHeight*.33)
	RightChatBaseFrame:SetPoint("BOTTOMRIGHT", UIParent,"BOTTOMRIGHT", 6, -6)
	RightChatBaseFrame:SetFrameStrata("BACKGROUND")
	RightChatBaseFrame:SetFrameLevel(1)
	RightChatBaseFrame:SetAlpha(1)
	RightChatBaseFrame:SetBackdrop(backdrop)
	RightChatBaseFrame:SetBackdropColor(1.0, 1.0, 1.0)

	
-- This is the Center Main Frame Chunk
local frame = CreateFrame("frame", "CenterBase", UIParent, BackdropTemplateMixin and "BackdropTemplate")
	CenterBase:SetWidth(resolWidth*1.005)
	CenterBase:SetHeight(resolHeight*.21)
	CenterBase:SetPoint("BOTTOM", UIParent,"BOTTOM", 0, -6)
	CenterBase:SetFrameStrata("BACKGROUND")
	CenterBase:SetFrameLevel(2)
	CenterBase:SetBackdrop(backdrop)
	
-- This is map frame chunk
local frame = CreateFrame("frame", "CenterMapBase", UIParent, BackdropTemplateMixin and "BackdropTemplate")
	CenterMapBase:SetWidth(resolHeight*.21)
	CenterMapBase:SetHeight(resolHeight*.21)
	CenterMapBase:SetPoint("BOTTOM", UIParent,"BOTTOM", 0, -6)
	CenterMapBase:SetFrameStrata("BACKGROUND")
	CenterMapBase:SetFrameLevel(3)
	CenterMapBase:SetBackdrop(backdropClear)
-- this is top frame chunk
local frame = CreateFrame("frame", "TopFrame", UIParent, BackdropTemplateMixin and "BackdropTemplate")
	TopFrame:SetWidth(resolWidth*1.675)
	TopFrame:SetHeight(resolHeight*.042)
	TopFrame:SetPoint("TOPLEFT", UIParent,"TOPLEFT", -6, 6)
	TopFrame:SetFrameStrata("BACKGROUND")
	TopFrame:SetFrameLevel(1)
	TopFrame:SetAlpha(1)
	TopFrame:SetBackdrop(backdrop)
	
--Right SubFrame a.k.a. XP frame
local frame = CreateFrame("frame", "XPFrame", RightChatBaseFrame, BackdropTemplateMixin and "BackdropTemplate")
	XPFrame:SetWidth(resolWidth*.34)
	XPFrame:SetHeight(resolHeight*.04)
	XPFrame:SetPoint("TOPRIGHT", RightChatBaseFrame,"TOPRIGHT", 0, 0)
	XPFrame:SetFrameStrata("BACKGROUND")
	XPFrame:SetFrameLevel(2)
	XPFrame:SetAlpha(1)
	XPFrame:SetBackdrop({
		bgFile =  "Interface\\AddOns\\_Deranjata\\media\\cast\\Lines",
		edgeFile  = "Interface\\DialogFrame\\UI-DialogBox-Border",
		edgeSize  = 20,
		insets = { left = 4, right = 4, top = 4, bottom = 4 }
		})
	XPFrame:SetBackdropColor(0.1, 0.1, 0.1)
	
--Left SubFrame a.k.a. Atrifact Frame
local frame = CreateFrame("frame", "artifactFrame", LeftChatBaseFrame, BackdropTemplateMixin and "BackdropTemplate")
	artifactFrame:SetWidth(resolWidth*.34)
	artifactFrame:SetHeight(resolHeight*.04)
	artifactFrame:SetPoint("TOPRIGHT", LeftChatBaseFrame,"TOPRIGHT", 0, 0)
	artifactFrame:SetFrameStrata("MEDIUM")
	artifactFrame:SetFrameLevel(2)
	artifactFrame:SetAlpha(1)
	artifactFrame:SetBackdrop  ({
	bgFile =  "Interface\\AddOns\\_Deranjata\\media\\cast\\Lines",
		edgeFile  = "Interface\\DialogFrame\\UI-DialogBox-Border",
		edgeSize  = 20,

	insets = { left = 4, right = 4, top = 4, bottom = 4 }
})
	artifactFrame:SetBackdropColor(0.1, 0.1, 0.1)
	
	
	
	
	--------------------------------------------------------------------------
--now lets adjust the UIParent frame and set the chat frames into position 
--------------------------------------------------------------------------
local aspect = CreateFrame("frame", nil, UIParent)
aspect:RegisterEvent("PLAYER_ENTERING_WORLD")
aspect:SetScript("OnEvent", function(self, event)               
    UIParent:SetScale(0.59) -- DO NOT CHANGE THIS
    ChatFrame2:ClearAllPoints()
    ChatFrame1:ClearAllPoints()
	ChatFrame1:SetPoint("BOTTOMLEFT", LeftChatBaseFrame, "BOTTOMLEFT", 8, 0)
	ChatFrame1:SetPoint("TOPRIGHT", LeftChatBaseFrame, "BOTTOMLEFT", (resolWidth*.323), (resolHeight*.310))
	ChatFrame2:SetPoint("BOTTOMLEFT", RightChatBaseFrame, "BOTTOMLEFT", 8, 0)
	ChatFrame2:SetPoint("TOPRIGHT", RightChatBaseFrame, "BOTTOMLEFT", (resolWidth*.323), (resolHeight*.161)) 
    aspect:UnregisterAllEvents()
end)
